#define MAX_OBJECTS_TO_VIEW 100

class InfoViewManager {
public:
	InfoViewManager();
	void addObject( CCubesView* original, INodeObject* o );
	void scaleObjectX( int percent );
	void scaleObjectY( int percent );
	void scaleObjectZ( int percent );
	void scaleObject( int percent );
	void MoveUp();
	void MoveDown();
	void MoveRight();
	void MoveLeft();
	void MoveIn();
	void MoveOut();
	void Show();
	void Hide();
	void Cycle();
	void Taller() { scaleObjectY( 105 ); }
	void Shorter() { scaleObjectY( 95 ); }
	void Bigger() { scaleObject( 105 ); }
	void Smaller() { scaleObject( 95 ); }
	void FadeOut();
	void FadeIn();
	void Fatter() { scaleObjectZ( 105 ); scaleObjectX( 105 ); }
	void Thinner() { scaleObjectZ( 95 ); scaleObjectX( 95 ); }
	void SetMax( char* maxstr );
	void SetValue( char* valuestr );
	void setObject( char* name );
	bool hasMaterial();
	ISFColorObject* getDiffuseColor() { return( colorList[ currentIdx ] ); }
	ISFColorObject* getEmissiveColor() { return( ecolorList[ currentIdx ] ); }
	void setTransparency( ISFFloatObject* t );
	char* getObjectAt( int offset );
	bool isVisible( int offset );
private:
	int getIdx( char* name );
	int transformIdx;
	int currentIdx;
	int internalMax;
	bool visible[MAX_OBJECTS_TO_VIEW];
	ISFColorObject* colorList[MAX_OBJECTS_TO_VIEW];
	ISFColorObject* ecolorList[MAX_OBJECTS_TO_VIEW];
	ISFVec3fObject* locationList[MAX_OBJECTS_TO_VIEW];
	ISFVec3fObject* scaleList[MAX_OBJECTS_TO_VIEW];
	ISFFloatObject* transparencyList[ MAX_OBJECTS_TO_VIEW ];
	char* transformNameList[MAX_OBJECTS_TO_VIEW];
	int value[MAX_OBJECTS_TO_VIEW];
	bool gotMaterial[ MAX_OBJECTS_TO_VIEW ];
};