/* include readline */
#include  <winsock2.h>
#define MAXLINE 5000

static int
my_read(int fd, char *ptr)
{
	static int	read_cnt = 0;
	static char	*read_ptr;
	static char	read_buf[MAXLINE];

	if (read_cnt <= 0) {
		if ( (read_cnt = recv(fd, read_buf, sizeof(read_buf), 0)) < 0) {
			return(-1);
		} else if (read_cnt == 0)
			return(0);
		read_ptr = read_buf;
	}

	read_cnt--;
	*ptr = *read_ptr++;
	return(1);
}

int
readline(int fd, void *vptr, int maxlen)
{
	int		n, rc;
	char	c, *ptr;

	ptr = vptr;
	for (n = 1; n < maxlen; n++) {
		if ( (rc = my_read(fd, &c)) == 1) {
			if (c == '\n')
				break;	/* newline is stored, like fgets() */
			if ((( n == 1 ) || ( n == 2 )) && !isprint( c )) {
				ptr = vptr;
			} else {
				*ptr++ = c;
			}
		} else if (rc == 0) {
			if (n == 1)
				return(0);	/* EOF, no data read */
			else
				break;		/* EOF, some data was read */
		} else
			return(-1);		/* error, errno set by read() */
	}

	*ptr = 0;	/* null terminate like fgets() */
	return(n);
}
/* end readline */

int
Readline(int fd, void *ptr, int maxlen)
{
	int		n;

	if ( (n = readline(fd, ptr, maxlen)) < 0)
		return(-1);
	return(n);
}
